#define pin_pH A1  // pin sur lequel la sonde est branchee 
#define VREF 5000.0 // definition de VREF pour la conversion en volts    
unsigned long int avg_pH;  
int buf[10],temp;
 
void setup(){
  Serial.begin(9600); // frequence de communication avec le port serie
}

void loop(){
  for(int i=0;i<10;i++)      
  { 
    buf[i]=analogRead(pin_pH); // mesure de signal analogique x10
    delay(10);
  }
  for(int i=0;i<9;i++)  // classe les valeurs    
  {
    for(int j=i+1;j<10;j++)
    {
      if(buf[i]>buf[j])
      {
        temp=buf[i];
        buf[i]=buf[j];
        buf[j]=temp;
      }
    }
  }
  avg_pH=0;
  for(int i=2;i<8;i++)                      
    avg_pH+=buf[i]; // somme les 6 mesures medianes  
  float V=(float)avg_pH*(float)VREF/1024.0/6.0; // signal en mV   
  float phValue = phValue = 2.47*0.001*V+4.02;                 
  Serial.print("V = ");
  Serial.print(V,2);  // affichage de la tension sur le port serie
  Serial.print(" mV");
  Serial.println(phValue);
  delay(1000);  // repete la mesure toutes les 1000 ms
  
}
